// SimpleChatView.cpp : CSimpleChatView NX̓̒`s܂B
//

#include "stdafx.h"

#include "MainFrm.h"
#include "SimpleChat.h"
#include "ConnectDlg.h"
#include "SimpleChatDoc.h"
#include "CntrItem.h"
#include "SimpleChatView.h"

#define GETR(c) ((BYTE)(c & 0xFF))
#define GETG(c) ((BYTE)((c & 0xFF00) >> 8))
#define GETB(c) ((BYTE)((c & 0xFF0000) >> 16))

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CStatusBar* pStatusBar;

/////////////////////////////////////////////////////////////////////////////
// CSimpleChatView

IMPLEMENT_DYNCREATE(CSimpleChatView, CRichEditView)

BEGIN_MESSAGE_MAP(CSimpleChatView, CRichEditView)
	//{{AFX_MSG_MAP(CSimpleChatView)
	ON_WM_DESTROY()
	ON_WM_CREATE()
	ON_COMMAND(IDM_CONNECT, OnConnectCommand)
	ON_COMMAND(IDM_DISCONNECT, OnDisconnectCommand)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSimpleChatView NX̍\z/

CSimpleChatView::CSimpleChatView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	m_Sock = NULL;
	m_bTimerFlag = FALSE;
}

CSimpleChatView::~CSimpleChatView()
{
	if(m_Sock != NULL){
		m_Sock->Close();
		delete m_Sock;
	}
}

BOOL CSimpleChatView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CRichEditView::PreCreateWindow(cs);
}

void CSimpleChatView::OnInitialUpdate()
{
	CRichEditView::OnInitialUpdate();


	// ̗]ݒ肵܂ (720 twips = 1/2 inch).
	SetMargins(CRect(720, 720, 720, 720));
}

void CSimpleChatView::OnDestroy()
{
	// ŎɃACeANeBx[g܂; ͕r[
	// gpĂꍇɂ͏dvłB
   CRichEditView::OnDestroy();
   COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
   if (pActiveItem != NULL && pActiveItem->GetActiveView() == this)
   {
      pActiveItem->Deactivate();
      ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
   }
}


/////////////////////////////////////////////////////////////////////////////
// CSimpleChatView NX̐ff

#ifdef _DEBUG
void CSimpleChatView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CSimpleChatView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}

CSimpleChatDoc* CSimpleChatView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSimpleChatDoc)));
	return (CSimpleChatDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSimpleChatView NX̃bZ[W nh

CSimpleChatView* CSimpleChatView::GetView()
{
	CView *pView = (CView*)((CFrameWnd*)(AfxGetApp()->m_pMainWnd))->GetActiveView();

	if(pView == NULL) return NULL;
	if(pView->IsKindOf(RUNTIME_CLASS(CSimpleChatView)) == FALSE) return NULL;

	return (CSimpleChatView*)pView;
}

void CSimpleChatView::OnConnect(int nError)
{
	CString str;
	int r,g,b;

	r = GETR(m_dlgConnect.m_color);
	g = GETG(m_dlgConnect.m_color);
	b = GETB(m_dlgConnect.m_color);

	str.Format("LGIN %03d%03d%03d %s\r\n", r, g, b, m_dlgConnect.m_strHandle);
	m_Handle.Format("%s >", m_dlgConnect.m_strHandle);
	m_Sock->Send(str, str.GetLength());

	SetTimer(1, 60000, NULL);
	m_bTimerFlag = TRUE;
}

void CSimpleChatView::OnClose(int nError)
{
	delete m_Sock;
	m_Sock = NULL;
	pStatusBar->SetPaneText(1,"ڑ");
	((CMainFrame*)(AfxGetApp()->m_pMainWnd))->SetStaticText("");
}

void CSimpleChatView::OnSend(int nError)
{
}

void CSimpleChatView::OnRecv(int nError, char *buf)
{
	char seps[] = "\n";
	int colr, colg, colb;
	char handle[50], data[256];
	CString line;

	if(m_bTimerFlag == TRUE){
		KillTimer(1);
		m_bTimerFlag = FALSE;
		((CMainFrame*)(AfxGetApp()->m_pMainWnd))->SetStaticText(m_Handle);
		pStatusBar->SetPaneText(1,"ڑ");
	}

	m_RecvBuf += buf;

	line = GetLine(m_RecvBuf);

	while(line.IsEmpty() == FALSE){
		if(line.Find("OK", 0) == 0){
		}else if(line.Find("END", 0) == 0){
			break;
		}else if(line.Find("ERR", 0) == 0){
			line = GetLine(m_RecvBuf);
			if(line.IsEmpty() == FALSE)	MessageBox(line, "G[", MB_OK | MB_ICONSTOP);
			break;
		}else{
			CString str;
			memset(handle, 0, 50);
			memset(data, 0, 256);
            sscanf(line, "%03d%03d%03d\t%s\t%s", &colr, &colg, &colb, &handle, &data);
			if(strlen(handle) != 0 && strlen(data) != 0){
				str.Format("%s : %s\r\n", handle, data);
				PrintLine(str, RGB(colr, colg, colb));
			}
		}
	
		line = GetLine(m_RecvBuf);
	}
}

int CSimpleChatView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CRichEditView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ
	CRichEditCtrl& ctrl = GetRichEditCtrl();
	ctrl.SetReadOnly();
	
	return 0;
}

void CSimpleChatView::PrintLine(CString str, COLORREF color)
{
	CHARFORMAT format;
	CRichEditCtrl& ctrl = GetRichEditCtrl();

	format.dwEffects = 0;
	format.dwMask = CFM_COLOR;
	format.crTextColor = color;

	ctrl.SetSel(-1,-1);
	ctrl.SetSelectionCharFormat(format);
	ctrl.ReplaceSel(str);

	ctrl.SetModify(FALSE);
}

void CSimpleChatView::OnConnectCommand() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_Sock != NULL) return;

	m_dlgConnect.m_nPort = 12345;

	if(m_dlgConnect.DoModal() != IDOK) return;

	CString str;
	int err;
	m_Sock = new CSimpleChatSock();

	if(m_Sock == NULL) return;

	if (!m_Sock->Create())
	{
		AfxMessageBox("Socket̍쐬Ɏs܂");
		delete m_Sock;
		m_Sock = NULL;
		return;
	} 

	if(!m_Sock->Connect(m_dlgConnect.m_strHost, m_dlgConnect.m_nPort)){
		err = m_Sock->GetLastError();
		if(err != WSAEWOULDBLOCK){
			str.Format("G[܂ (%d)", err);
			MessageBox(str, "G[", MB_OK);
			delete m_Sock;
			m_Sock = NULL;
			return;
		}
	}

	pStatusBar->SetPaneText(1,"ڑ...");
}

void CSimpleChatView::OnDisconnectCommand() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	if(m_Sock == NULL) return;

	if(m_bTimerFlag == TRUE){
		KillTimer(1);
		m_bTimerFlag = FALSE;
	}

	m_Sock->ShutDown();
	m_Sock->Close();
	delete m_Sock;
	m_Sock = NULL;
	pStatusBar->SetPaneText(1,"ڑ");
	((CMainFrame*)(AfxGetApp()->m_pMainWnd))->SetStaticText("");
}

void CSimpleChatView::OnSendData(char* buf)
{
	if(m_Sock == NULL) return;

	CString str;

	if(strlen(buf) == 0){
		str.Format("RELD\r\n",buf);
		m_Sock->Send(str, str.GetLength());
	}else{
		str.Format("SEND %s\r\n",buf);
		m_Sock->Send(str, str.GetLength());
	}
}

void CSimpleChatView::OnTimer(UINT nIDEvent) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	switch(nIDEvent){
		case 1:
			m_bTimerFlag = FALSE;
			KillTimer(1);
			OnDisconnectCommand();
			MessageBox("܂łBT[o[|[gԍԈĂ\܂", "G[", MB_OK | MB_ICONSTOP);
			break;
	}
	CRichEditView::OnTimer(nIDEvent);
}

CString CSimpleChatView::GetLine(CString &str)
{
	int pin;
	CString ret;

	pin = str.Find("\n", 0);

	if(pin != -1){
		ret = str.Left(pin);
		str = str.Mid(pin+1);
	}else{
		ret = "";
	}

	return ret;
}
