/*========================================================*
                    Simple Chat Server
                         ver 0.01
                        2000/9/16
 *========================================================*/

/*---------------------*
      CN[h
 *---------------------*/
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/file.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <errno.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <time.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>


/*-----------------*
       萔
 *-----------------*/
#define LOGNAME         "chat.dat"
#define MAXLINE         20
#define MAXLEN          256
#define MAXNAME         30
#define DEFPORT         12345
#define BUFSIZE         1024
#define READ_TIMEOUT    300
#define RELOAD_TIME     5
#define MAXLOCKWAIT     120
#define MAXLOGIN        20

/*
#define LISTNAME        "list.dat"
*/

/*-----------------*
  VK^E\̐錾
 *-----------------*/
/*PORT^*/
typedef unsigned short PORT;

/*`bg̃f[^R[h*/
typedef struct _tag_data{
    long    wtime;
    char    data[MAXLEN];
}RECODE;


/*-----------------*
   O[oϐ
 *-----------------*/
int dfd = -1, mfd = -1;
int dsize, msize;
int sv_sock = -1, cl_sock = -1;
int loop = 1;
int ppid = 0;
int client = 0;

struct sockaddr_in sv_addr, cl_addr;

RECODE* pmap = NULL;
RECODE  recode_buf[MAXLINE];
char**  pname = NULL;
/*
char    name_list[MAXLOGIN][MAXNAME];
*/

time_t lasttime;
int colr = 0, colg = 0, colb = 0;
char handle[50];
char okmsg[] = "OK\r\n";
char endmsg[] = "END\r\n";
char errmsg[] = "ERR\r\nR}h܂\r\n";
char nologin[] = "ERR\r\n܂OCĂ܂\r\n";
char logined[] = "ERR\r\nłɃOCĂ܂\r\n";
char lockerr[] = "ERR\r\nrW[Ԃ̂ߗv͎󂯕t܂ł\r\n";
char svstop[] = "ERR\r\nT[o[~܂\r\n";
char loginfull[] = "ERR\r\nőڑ𒴂Ă̂ŃOCł܂\r\n";

/*-----------------*
    vg^Cv
 *-----------------*/
void setsignal();
void session();
void errexit(int retnum, const char* funcname);
int getlock(int fd, int type);
void* createmap(int* fd, const char* file, int* memsize);
void deletemap(int fd, void* map, int size);
void childsig(int signum);
void endsig(int signum);
void alarmsig(int signum);
void clientsig(int signum);


/*-----------------------------------------------*
 int main(int argc, char* argv[])
      Gg[|CgB
      \PbgE}bvƐڑ̑ҋ@
 *-----------------------------------------------*/
int main(int argc, char* argv[])
{
    int adlen, ret;
    int pid;
    unsigned short port = DEFPORT;
    sigset_t mask;

#ifdef __CYGWIN__
    fd_set rset;
#endif /* __CYGWIN__ */

    ppid = getpid();

    if(argc < 2){
        port = DEFPORT;
    }else{
        port = (unsigned short)strtoul(argv[1], NULL, 0);
    }

    setsignal();

    dsize = MAXLINE * sizeof(RECODE);
    pmap = (RECODE*)createmap(&dfd, LOGNAME, &dsize);
    if(pmap == NULL) errexit(-1, NULL);
/*
    msize = MAXLOGIN * MAXNAME;
    pname = (char**)createmap(&mfd, LISTNAME, &msize);
    if(pname == NULL) errexit(-1, NULL);
*/
    bzero((char*)&sv_addr, sizeof(sv_addr));
    sv_addr.sin_family = AF_INET;
    sv_addr.sin_port = htons(port);
    sv_addr.sin_addr.s_addr = INADDR_ANY;

    sv_sock = socket(AF_INET, SOCK_STREAM, 0);

    if(sv_sock < 0) errexit(-1, "socket");

    if(bind(sv_sock, (struct sockaddr*)&sv_addr, sizeof(sv_addr)) < 0) errexit(-1, "bind");
    if(listen(sv_sock, 1) < 0) errexit(-1, "listen");

    while(loop){

#ifdef __CYGWIN__
        /*
          CygwinɂacceptubN͂ȂVOinh쓮Ȃ̂
          ̍ƂselectŐڑҋ@Ă܂(Cygwin 1.1.4ŊmF)
        */
        FD_ZERO(&rset);    /* fds̏ */
        FD_SET(sv_sock, &rset);

        if (select(sv_sock+1, &rset, NULL, NULL, NULL) == -1){
            if(errno == EINTR) continue;
            perror("select");
            close(sv_sock);
            break;
        }

        if (FD_ISSET(sv_sock, &rset) != 0) {
#endif /* __CYGWIN__ */

            adlen = sizeof(cl_addr);
            cl_sock = accept(sv_sock, (struct sockaddr*)&cl_addr, &adlen);
            if(cl_sock < 0){
                if(errno == EINTR) continue;
                perror("accept");
                close(sv_sock);
                break;
            }

            if(client >= MAXLOGIN){
                write(cl_sock, loginfull, strlen(loginfull));
                close(cl_sock);
                continue;
            }

            pid = fork();

            switch(pid){
                case -1:
                    errexit(-1, "fork");
                case 0:
                    close(sv_sock);
                    sv_sock = -1;
                    lasttime = time(0);
                    session();
                    close(cl_sock);
                    cl_sock = -1;
                    if(getppid() == ppid) kill(ppid, SIGUSR1);
                    return 0;
                default:
                    close(cl_sock);
                    cl_sock = -1;
                    sigemptyset(&mask);
                    sigaddset(&mask, SIGUSR1);
                    sigprocmask(SIG_BLOCK, &mask, NULL);
                    client++;
                    sigprocmask(SIG_UNBLOCK, &mask, NULL);
            }

#ifdef __CYGWIN__
        }
#endif /* __CYGWIN__ */

    }

    errexit(0, NULL);
}

/*-------------------------------------*
  void setsignal()
     VOĩZbg
 *-------------------------------------*/
void setsignal()
{
    struct sigaction act;

    act.sa_handler = endsig;
    act.sa_flags = 0;
    sigemptyset(&act.sa_mask);
    sigaddset(&act.sa_mask, SIGINT);
    sigaddset(&act.sa_mask, SIGTERM);
    sigaddset(&act.sa_mask, SIGQUIT);

    if(sigaction(SIGINT, &act, 0) != 0) errexit(-1, "sigaction");
    if(sigaction(SIGTERM, &act, 0) != 0) errexit(-1, "sigaction");
    if(sigaction(SIGQUIT, &act, 0) != 0) errexit(-1, "sigaction");

    act.sa_handler = alarmsig;
    act.sa_flags = 0;
    sigemptyset(&act.sa_mask);
    sigaddset(&act.sa_mask, SIGALRM);

    if(sigaction(SIGALRM, &act, 0) != 0) errexit(-1, "sigaction");

    act.sa_handler = childsig;
    act.sa_flags = 0;
    sigemptyset(&act.sa_mask);

    if(sigaction(SIGCHLD, &act, 0) != 0) errexit(-1, "sigaction");

    act.sa_handler = clientsig;
    act.sa_flags = 0;
    sigemptyset(&act.sa_mask);
    sigaddset(&act.sa_mask, SIGUSR1);

    if(sigaction(SIGUSR1, &act, 0) != 0) errexit(-1, "sigaction");
}


/*-------------------------------------*
  void readfile()
     OǂݍŐVK𑗐M
 *-------------------------------------*/
void readfile()
{
    char data[2048];
    char senddata[2048];
    char *pin[4];
    long ftime, buftime;
    int i,j;
    
    if(cl_sock <= 0) return;

    if(getlock(dfd, F_RDLCK) == -1){
        write(cl_sock, lockerr, strlen(lockerr));
        return;
    }

    if(pmap[0].wtime == lasttime){
        getlock(dfd, F_UNLCK);
        return;
    }

    write(cl_sock, okmsg, strlen(okmsg));

    for(i = 0; i < MAXLINE; i++){
        if(pmap[i].wtime <= lasttime) break;
    }

    for(j = i-1; j >= 0; j--){
        write(cl_sock, pmap[j].data, strlen(pmap[j].data));
    }
    
    write(cl_sock, endmsg, strlen(endmsg));

    lasttime = pmap[0].wtime;

    getlock(dfd, F_UNLCK);
}

/*---------------------------------------*
  writefile(char* chat)
      Vɒǉ
 *---------------------------------------*/
void writefile(char* chat)
{
    int i;

    if(getlock(dfd, F_WRLCK) == -1){
        write(cl_sock, lockerr, strlen(lockerr));
        return;
    }

    recode_buf[0].wtime = time(0);
    if(pmap[0].wtime <= recode_buf[0].wtime) recode_buf[0].wtime = pmap[0].wtime + 1;

    strcpy(recode_buf[0].data, chat);

    for(i = 1; i < MAXLINE; i++){
        memcpy(&recode_buf[i], &pmap[i-1], sizeof(RECODE));
    }

    memcpy(pmap, &recode_buf, sizeof(RECODE) * MAXLINE);
    msync((void*)pmap,sizeof(RECODE) * MAXLINE,0);

    if(getlock(dfd, F_UNLCK) == -1){
        write(cl_sock, lockerr, strlen(lockerr));
        return;
    }

    raise(SIGALRM);
}

/*------------------------------------------------------*
  int readtimeo(int sock)
     ^CAEg\Pbgǂݍ݉\ɂȂ̂҂
 *------------------------------------------------------*/
int readtimeo(int sock)
{
    int    ret;
    int    time = READ_TIMEOUT;
    fd_set rset;
    struct timeval tv;

    FD_ZERO(&rset);
    FD_SET(sock, &rset);

again:

    tv.tv_sec  = time;
    tv.tv_usec = 0;

    ret = select(sock+1, &rset, NULL, NULL, &tv);

    if(ret == -1){
        if(errno == EINTR && getppid() == ppid){
            time = time - RELOAD_TIME;
            if(time <= 0) return 0;
            goto again;
        }
        if(errno != EINTR) perror("select");
    }else if(ret != 0){
        if (FD_ISSET(sock, &rset) == 0) goto again;
    }

    return ret;
}

/*--------------------------------------------*
  static ssize_t iread(char* ptr)
     obt@ꕶǂݍށAobt@̂΂
     VɃ\Pbgobt@ɓǂݍ
 *--------------------------------------------*/
static ssize_t iread(char* ptr)
{
    static int      read_cnt = 0;
    static char*    read_ptr;
    static char     read_buf[BUFSIZE];
    
    if(read_cnt <= 0){
        if(readtimeo(cl_sock) <= 0){
           return -1;
        }else{
again:
            read_cnt = read(cl_sock, read_buf, sizeof(read_buf));
            if(read_cnt < 0){
                if(errno == EINTR) goto again;
                return -1;
            }else if(read_cnt == 0){
                return 0;
            }
            read_ptr = read_buf;
        }
    }
    
    read_cnt--;
    *ptr = *read_ptr++;
    return 1;
}

/*-----------------------------------------*
  ssize_t readline(void* vptr, size_t maxlen)
    sǂݍ
 *-----------------------------------------*/
ssize_t readline(void* vptr, size_t maxlen)
{
    ssize_t n,rc;
    char    c,*ptr;
    
    ptr = vptr;
    for(n = 1; n < maxlen; n++){
        rc = iread(&c);
        if(rc == 1){
            *ptr++ = c;
            if(c == '\n') break;
        }else if(rc == 0){
            if(n == 1) return 0;
            break;
        }else{
            return -1;
        }
    }
    *ptr = '\0';
    return n;
}

/*---------------------------------------*
  session()
    T[o[֐
 *---------------------------------------*/
void session()
{
    int ret, flglgin = 0;
    char recvdat[1024], adddata[MAXLEN], scanfdat[64];

    memset(handle, 0, 50);

    while(1){
        ret = readline(recvdat, 1023);
        if(ret == 0){
            cl_sock = -1;
            if(flglgin != 0){
                flglgin = 0;
                sprintf(adddata, "%03d%03d%03d\tbZ[W\t%sOAEg܂\r\n", colr, colg, colb, handle);
                writefile(adddata);
                alarm(0);
            }
            return;
        }

        if(ret == -1){
            if(flglgin != 0){
                flglgin = 0;
                if(getppid() == ppid){
                    sprintf(adddata, "%03d%03d%03d\tbZ[W\t%s̓^CAEĝ߃OAEg܂\r\n", colr, colg, colb, handle);
                    writefile(adddata);
                }else{
                    write(cl_sock, svstop, strlen(svstop));
                }
                alarm(0);
            }
            return;
        }
        
        if(strncmp(recvdat, "LGIN ", 5) == 0){
            if(flglgin == 0){
                sprintf(scanfdat, "%%03d%%03d%%03d %%%ds", MAXNAME);
                sscanf(recvdat + 5, scanfdat, &colr, &colg, &colb, &handle);
                if(strlen(handle) != 0){
                    sprintf(adddata, "%03d%03d%03d\tbZ[W\t%sOC܂\r\n", colr, colg, colb, handle);
                    writefile(adddata);
                    flglgin = 1;
                    alarm(RELOAD_TIME);
                }else{
                    write(cl_sock, errmsg, strlen(errmsg));
                }
            }else{
                write(cl_sock, logined, strlen(logined));
            }
        }else if(strncmp(recvdat, "LGOT", 4) == 0){
            if(flglgin != 0){
                flglgin = 0;
                sprintf(adddata, "%03d%03d%03d\tbZ[W\t%sOAEg܂\r\n", colr, colg, colb, handle);
                writefile(adddata);
                alarm(0);
            }else{
                write(cl_sock, nologin, strlen(nologin));
            }
        }else if(strncmp(recvdat, "RELD", 4) == 0){
            if(flglgin != 0){
                raise(SIGALRM);
            }else{
                write(cl_sock, nologin, strlen(nologin));
            }
        }else if(strncmp(recvdat, "SEND ", 5) == 0){
            if(flglgin != 0){
                sprintf(adddata, "%03d%03d%03d\t%s\t", colr, colg, colb, handle);
                strncat(adddata, recvdat + 5, (MAXLEN - 9) - strlen(handle));
                writefile(adddata);
            }else{
                write(cl_sock, nologin, strlen(nologin));
            }
        }else{
            write(cl_sock, errmsg, strlen(errmsg));
        }
    }
}

/*----------------------------------------------------------*
  void* createmap(int* fd, const char* file, int* memsize)
     t@C}bv쐬
 *----------------------------------------------------------*/
void* createmap(int* fd, const char* file, int* memsize)
{
    int psize, size;
    char c;
    void* pv;

    if((*fd = open(file, O_RDWR | O_CREAT, 0666)) == -1){
        perror("open");
        return NULL;
    }

    psize = getpagesize();

    *memsize = (*memsize / psize + 1) * psize;

    if(lseek(*fd, *memsize, SEEK_SET)<0){
        perror("lseek");
        return NULL;
    }

    if(read(*fd, &c, sizeof(char)) == -1){
        c = '\0';
    }

    if(write(*fd, &c, sizeof(char)) == -1){
        perror("write");
        return NULL;
    }

    pv = mmap(NULL, *memsize, PROT_READ|PROT_WRITE, MAP_SHARED, *fd, 0);

    if(pv == (void*)-1){
        perror("mmap");
        return NULL;
    }

    return pv;
}

/*--------------------------------------------*
  void deletemap(int fd, void* map, int size)
      t@C}bv폜
 *--------------------------------------------*/
void deletemap(int fd, void* map, int size)
{
    msync(map,size,0);

    if(munmap(map, size) == -1){
        perror("munmap");
    }

    close(fd);
}

/*--------------------------------------------------*
  int getlock(int fd, int type)
      bN̍쐬Ƒҋ@
 *--------------------------------------------------*/
int getlock(int fd, int type)
{
    struct flock lockinfo;
    int i = 0;

    lockinfo.l_whence = SEEK_SET;
    lockinfo.l_start = 0;
    lockinfo.l_len = 0;
    lockinfo.l_type = type;

    while(1){
        if(!fcntl(fd, F_SETLK, &lockinfo)) return 0;
        sleep(1);
        if(i > MAXLOCKWAIT) return -1;
        i++;
    }
}

/*----------------------------------------------*
  void errexit(int retnum, const char* funcname)
      I
 *----------------------------------------------*/
void errexit(int retnum, const char* funcname)
{
    if(funcname != NULL) perror(funcname);
    if(cl_sock >= 0) close(cl_sock);
    if(sv_sock >= 0) close(sv_sock);
    if(pmap != NULL) deletemap(dfd, pmap, dsize);
    if(pname != NULL) deletemap(mfd, pname, msize);
    exit(retnum);
}

/*---------------------------------------------------*
  void endsig(int signum)
     IVOȉ
 *---------------------------------------------------*/
void endsig(int signum)
{
    loop = 0;
    if(sv_sock >= 0){
        close(sv_sock);
        sv_sock = -1;
    }
}

/*----------------------------------------------------*
   void chilesig(int signum)
      SIGCHLDVOȉ
 *----------------------------------------------------*/
void childsig(int signum)
{
    int status;
    waitpid(-1, &status, WNOHANG);
}

/*----------------------------------------------------*
   void alarmsig(int signum)
      SIGALRMVOȉ
 *----------------------------------------------------*/
void alarmsig(int signum)
{
    readfile();
    alarm(RELOAD_TIME);
}

/*----------------------------------------------------*
   void clientsig(int signum)
      SIGUSR1VOȉ
      (NCAg̃OAEgm点̂Ɏgp)
 *----------------------------------------------------*/
void clientsig(int signum)
{
    client--;
}
